unit BezMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, system.Math,
  System.UITypes, System.Types, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs, VCLTee.Chart, Vcl.ExtDlgs,
  Winapi.wincodec, Winapi.ActiveX;

//------------------------------------------------------------------------
// delphi XE3,4TWICImage.SaveToStream oO΍łAȊO͕svłB
//------------------------------------------------------------------------
Type
  TWICImage = Class (Vcl.Graphics.TWICImage)
    public
      procedure SaveToStream(Stream: TStream); override;
    end;
//-----------------------------------------------------------------------

type
  TForm1 = class(TForm)
    Image1: TImage;
    FileOpenBtn: TButton;
    Image2: TImage;
    Chart1: TChart;
    Series1: TBarSeries;
    OpenPictureDialog1: TOpenPictureDialog;
    ContRastBtn: TButton;
    SorceBtn: TButton;
    Chart2: TChart;
    Series2: TBarSeries;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    Label1: TLabel;
    SLabel: TLabel;
    C1Label: TLabel;
    C2Label: TLabel;
    ELabel: TLabel;
    GresetBtn: TButton;
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ContRastBtnClick(Sender: TObject);
    procedure SorceBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure GresetBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure BezierCurve;
    procedure DrawEllipse(X, Y: Integer);
    procedure BezierTableSet;
    procedure Ghrest;                             // ␳OtZbg
  public
    { Public 錾 }
    function BezierTable(x: integer): double;
    function quadratic(a, b, c:double): double;   // 񎟕̉
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW = 400;                              // \TCY
  MoveR   =   5;                              // xWF|Cgړ۔a

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  GHeight       : Integer;                    // ̓f[^[摜
  GWidth        : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C
  HistMat       : array[0..255] of Integer;   // qXgOz
  HistMatB      : array[0..255] of Integer;   // qXgOz

  X0, X1, X2, X3: Integer;                    // xWFȐ_
  Y0, Y1, Y2, Y3: Integer;
  Origin        : TPoint;
  Drawing       : Boolean;
  Dpalette      : array[0..255] of Byte;
  MHeight       : integer;                    // Image1.height - 1
  zerof         : boolean;

//------------------------------------------------------------------------------
// delphi XE3,4TWICImage.SaveToStreamoO΍łAdelphi XE3,4ȊO͕svłB
//------------------------------------------------------------------------------
procedure TWICImage.SaveToStream(Stream: TStream);
var
  FGData: TMemoryStream;
  Encoder: IWICBitmapEncoder;
  Frame: IWICBitmapFrameEncode;
  Props: IPropertyBag2;
  LStreamAdapter: IStream;
  PixelFormat: TGUID;
  LStream: IWICStream;
  Palette: IWICPalette;
begin
  FGData := TMemoryStream.Create;
  try
    LStreamAdapter := TStreamAdapter.Create(FGData);

    ImagingFactory.CreateStream(LStream);
    LStream.InitializeFromIStream(LStreamAdapter);
    ImagingFactory.CreateEncoder(EncoderContainerFormat, guid_null, Encoder);

    Encoder.Initialize(LStream, WICBitmapEncoderNoCache);
    Encoder.CreateNewFrame(Frame, Props);

    Frame.Initialize(Props);
    Handle.GetPixelFormat(PixelFormat);
    Frame.SetPixelFormat(PixelFormat);

    Frame.SetSize(Width, Height);

    ImagingFactory.CreatePalette(Palette);
    Handle.CopyPalette(Palette);
    Frame.SetPalette(Palette);
    Frame.WriteSource(Handle, nil);
    Frame.Commit;
    Encoder.Commit;

    FGData.Position := 0;
    Stream.CopyFrom(FGData, FGData.Size);
  finally
    FGData.Free;
  end;
end;

//----------------------------------------------------------------------

//**************************************************
// 񎟋yшꎟ̉
//**************************************************
function TForm1.quadratic(a, b, c:double): double;   // 񎟕̉
var
  xc0       : double;
  xf1, xf2  :double;
begin
  xc0 := b * b - 4 * a * c;
  if a <> 0 then begin                  // a <> 0 Ȃ񎟕(炭͖̏Ǝv܂)
    if xc0 < 0 then begin               // [gJȂ̂ŉȂ
      xf1 := 0;
      xf2 := 0;
    end
    else begin                          // 
      xf1 := (-b + sqrt(xc0)) / 2 / a;
      xf2 := (-b - sqrt(xc0)) / 2 / a;
    end;
    if (xf1 > 0) and (xf2 > 0)then
      if xf2 < xf1 then xf1 := xf2;     // ̒l̗p
    if (xf1 < 0) and (xf2 >= 0) then    // ̒l̗p
      xf1 := xf2;
  end
  else                                  // a = 0 ̏ꍇ͈ꎟ
  begin
    xf1 := - c / b;                     // ꎟ̉
  end;
  result := xf1;
end;

//***************************************************
// xl ỎsxWFtl߂܂
//***************************************************
function TForm1.BezierTable(x: integer): double;
var
  a, b, c         : double;
  a0, a1, a2, a3  : double;
  p, q, d2, d     : double;
  ang3, cc, u3    : double;
  v1, u1          : double;
  ss, r           : double;
  ang             : double;
  xf1, xf2, xf3   : double;

  function cubicroot(a :double): double;     // 
  begin
    result := power(abs(a), 1 / 3) * sign(a);
  end;

  procedure printComplex;   // 1
  begin
    u3 := (q + d) / 2;
    u1 := cubicroot(u3);
    u3 := (d - q) / 2;
    v1 := cubicroot(u3);
    xf1 := u1 - v1 - a / 3;
  end;

  procedure printZero;     // 
  begin
    xf1:= cubicroot(4 * q) - a / 3;
  end;

  procedure PrintReal;          // Ȑo
  var
    tmp     : double;
    xa      : array[0..2] of double;
    II, JJ  : integer;
  begin
    ang3  := arctan2(d, q);
    ang   := ang3 / 3;
    cc    := cos(ang);
    ss    := sin(ang);
    r     := sqrt(abs(p));
    xa[0] := r *  ( cc + cc) - a / 3;
    xa[1] := r *  (-cc - sqrt(3) * ss) - a / 3;
    xa[2] := r *  (-cc + sqrt(3) * ss) - a / 3;
    // ̒lňԏl (O̂ŕKvȒlƂ肾܂)
    for JJ := 0 to 1 do                // ɕёւ
      for II := 0 to 1 do
        if xa[II] > xa[II + 1] then begin
          tmp := xa[II + 1];
          xa[II + 1] := xa[II];
          xa[II] := tmp;
        end;
    xf1 := xa[0];
    xf2 := xa[1];
    xf3 := xa[2];
    if xf1 < 0 then xf1 := xf2;  // }CiX玟̒l
    if xf1 < 0 then xf1 := xf3;  // }CiXXɎ̒l
  end;

  procedure Main;
  begin
    p := a * a / 9 - b / 3;
    q := -2 * a * a * a / 27 + a * b / 3 - c;
    d2 := q * q - 4 * p * p * p;                              // lvZ
    d := sqrt(abs(d2));
    if d2 > 0 then printComplex;  // 1
    if d2 = 0 then printZero;     // 
    if d2 < 0 then PrintReal;     // Ȑo
  end;

begin
  a0 := 3 * x1 - x0 - 3 * x2 + x3;      // (00,00),(85,85),(170,170),(255,255)̎a0[ɂȂ̂܂B
  a1 := 3 * x0 - 6 * x1 + 3 * x2;
  a2 := 3 * x1 - 3 * x0;
  a3 := x0 - x;

  zerof := false;
  if x <= x0 then begin    // x x0 菬
    result := y0;          // y0 ̒lԂ܂
    zerof := true;
    exit;
  end;
  if x >= x3 then begin
    result := y3;          // x x3傫Ȃ
    zerof := true;         // y3 ̒lԂ܂
    exit;
  end;
  if a0 = 0 then begin    // a0 [ɂȂꍇ 񎟖͈ꎟ̉߂܂
    result := quadratic(a1, a2, a3);
    exit;
  end;
  a := a1 / a0;
  b := a2 / a0;
  c := a3 / a0;
  Main;                    // Ỏ߂܂B
  result := xf1;           // xɑ΂xWFt ̒l
end;

//*****************************************************************
// xWFȐe[uZbg
// xWFȐ́Atϊ̂ŃOtǂݎe[u쐬
//*****************************************************************
procedure TForm1.BezierTableSet;
var
  xx  : Integer;
  t1              : Double;
  tm              : Double;
  B0, B1, B2, B3  : Double;
  Y               : Integer;
begin
  for xx := 0 to 255 do begin
    t1 := BezierTable(xx);        // x = 0`255 ̃xWF t l߂܂
    if not zerof then begin       // ỎƂylvZ
      tm := (1 - t1);
      B0 := tm * Tm * tm;
      B1 := 3 * t1 * tm * tm;
      B2 := 3 * t1 * t1 * tm;
      B3 := t1 * t1 * t1;
      Y := round(Y0 * B0 + Y1 * B1 + Y2 * B2 + Y3 * B3);
    end
    else y := round(t1);          // ȂƂ̒l

    if y > 255 then y := 255;
    if y < 0 then y:= 0;
    Dpalette[xx] := Y;            // e[uɒlZbg
  end;
end;

//************************************************
// RgXgCe[uɂRgXg
//************************************************
procedure TForm1.ContRastBtnClick(Sender: TObject);
var
  PBA         : PByteArray;
  PBB         : PByteArray;
  HH, WW      : Integer;
  PosP        : Integer;
  PosPB       : Integer;
  GD          : Integer;
begin
  BezierTableSet;                               // xWFȐe[u쐬
  Outputbitmap.PixelFormat := pf24bit;          // QSrbgtH[}bgw
  Outputbitmap.Width := GWidth;                 // ̉摜ɍ킹܂
  Outputbitmap.Height := GHeight;               // ̉摜ɍ킹܂
  for HH := 0 to 255 do HistMatB[HH] := 0;      // o͉摜qXgOf[^[
  // e[uɂPxϊ  qXgOf[^[쐬
  for HH := 0 to GHeight - 1 do begin
    PBA := InputDBitmap.ScanLine[HH];
    PBB := OutputBitmap.ScanLine[HH];
    for WW := 0 to GWidth - 1 do begin
      PosP  := WW * 4;                          // rbg}bvSbyte
      PosPB := WW * 3;                          // rbg}bvRbyte
      // e[uɂPxϊ
      PBB[PosPB    ] := Dpalette[PBA[PosP    ]];    // 
      PBB[PosPB + 1] := Dpalette[PBA[PosP + 1]];    // 
      PBB[PosPB + 2] := Dpalette[PBA[PosP + 2]];    // 
      // OCPxϊ
      GD := Round(0.114 * PBB[PosPB] + 0.587 * PBB[PosPB + 1] + 0.299 * PBB[PosPB + 2]);  // 0.299 * R + 0.587 * G + 0.114 * B
      inc(HistMatB[GD]);                            // qXgOz CNg
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, Outputbitmap);   // o͘gɕϔ{o
  Series2.Clear;                                    // RgXgԊҌqXgOOtNA
  for WW := 0 to 255 do Series2.Add(HistMatB[WW]);  // OtɃqXgO\
  FileSaveBtn.Enabled := True;
end;

//*********************************************
// xWFOtɃxWFw_\
//*********************************************
procedure TForm1.DrawEllipse(X, Y: Integer);
const
  R = 8;
begin
  Image1.Canvas.Ellipse(X - R, (MHeight - Y) - R, X + R, (MHeight - Y)  + R);
end;

//*****************************************************
// t@CI[u TImage ɓǂݍ
// 摜Ɓ@qXgO\
//*****************************************************
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  IHeight     : Integer;
  IWidth      : Integer;
  PBA         : PByteArray;
  HH, WW      : Integer;
  PosP        : Integer;
  GD          : Integer;
  MRect       : Trect;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        IHeight := Image2.Height;
        IWidth  := Image2.Width;
        if GHeight <= GWidth then                             // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth)
        else
          IWidth := Round(IHeight * GWidth / GHeight);
        Image2.Picture.Bitmap.SetSize(IWidth, IHeight);
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
        Image2.Canvas.StretchDraw(VRect, WIC);                // o͘gɕϔ{o
        InputDBitmap.Assign(WIC);                             // Tbitmap  TWICImageRs[
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  MRect := Rect(0, 0, Image2.Width, Image2.Height);
  Image2.Canvas.Brush.Style := bsSolid;
  Image2.Canvas.Brush.Color := clBtnface;
  Image2.Canvas.FillRect(MRect);                              // Canvas 摜
  Image2.Canvas.StretchDraw(VRect, InputDBitmap);             // o͘gɕϔ{o
  // ͉摜̃qXgO쐬 OC̋Pxɕϊ
  for WW := 0 to 255 do HistMat[WW] := 0;                     // qXgOzNA
  for HH := 0 to GHeight - 1 do begin                         // SDOTXL
    PBA := InputDBitmap.ScanLine[HH];
    for WW := 0 to GWidth - 1 do begin
      PosP  := WW * 4;
      GD := Round(0.114 * PBA[PosP] + 0.587 * PBA[PosP + 1] + 0.299 * PBA[PosP + 2]);  // 0.299 * R + 0.587 * G + 0.114 * B
      inc(HistMat[GD]);                                       // PxɑzʒuCNg
    end;
  end;
  Series1.clear;                                              // ͉摜qXgOOtNA
  for WW := 0 to 255 do Series1.Add(HistMat[WW]);             // ͉摜qXgO\
  ContRastBtn.Enabled := True;
  SorceBtn.Enabled := True;
end;

//*********************************************************
// RgXgϊf[^[ۑ
//*********************************************************
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;
  // TWicImageFormat@ϊtH[}bgR[hݒ
  function WFormatSet: Boolean;
  begin
    Result := False;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;                             // Z[uptB^[ݒ
  if not SavePictureDialog1.Execute then exit;                             // LZꂽI
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);                   // gqo
  if ExeStr = '' then begin                                                // gqݒ肳ĂȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;                                  // gq
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // TWicImageŎgpłgqmFƃtH[}bgZbg
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@C̒mF
  if Length(FnameTop) = Length(ExeStr) then begin
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage̐
  try
    WIC.Assign(OutputBitmap);                                              // WicImageɃrbg}bvZbg
    WIC.ImageFormat := WICF;                                               // o̓tH[}bgݒ
    WIC.SaveTofile(Fname);                                                 // wt@Cŕۑ
  finally
    WIC.Free;                                                              // TWicImagẻ
  end;
end;

//*********************************************
// ݒ
//*********************************************
procedure TForm1.FormCreate(Sender: TObject);
begin
  Top   := (Screen.Height - Height) div 2;
  Left  := (Screen.Width - Width)   div 2;
  Image1.Width := 257;                               // xWFȐpC[W 1傫̂͐`掞Ō̓_`悳Ȃ邽
  Image1.Height := 257;                              // xWFȐpC[W
  MHeight := Image1.Height - 1;
  BezierCurve;                                       // xWF}
  Image2.Height := 512;                              // 摜\pC[Wg
  Image2.Width  := 512;                              // 摜\pC[Wg
  InputDBitmap := TBitmap.Create;                    // ̓f[^[\prbg}bv
  OutputBitmap := TBitmap.Create;                    // o͉摜\prbg}bv
  ContRastBtn.Enabled := False;
  SorceBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  Ghrest;                             // ␳OtZbg
  Image2.Canvas.Brush.Style := BsSolid;
  Image2.Canvas.Brush.Color := ClWhite;
  Image2.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));  // Canvas 摜
end;

//********************************************
// I
//********************************************
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;

//*****************************************
// ␳Otݒ
//*****************************************
procedure TForm1.Ghrest;                             // ␳OtZbg
begin
  X0 := 0;                                           // X0`X3,Y0`y3 xWF֐pݒ45 n_X0
  Y0 := 0;                                           // n_ Y0
  X1 := 85;                                          // _ X1
  Y1 := 85;                                          // _ Y1
  X2 := 170;                                         // _ X2
  Y2 := 170;                                         // _ Y2
  X3 := 255;                                         // I_ X3
  Y3 := 255;                                         // I_ Y3
  BezierTableSet;
  BezierCurve;                                       // xWF}
  Label1.Caption := 'X= 0 Y= 0';
  SLabel.Caption := 'n_@@@ X= ' + intTostr(X0) + ' Y= ' + intTostr(Y0);
  C1Label.Caption := '_P@X= ' + intTostr(X1) + ' Y= ' + intTostr(Y1);
  C2Label.Caption := '_Q@X= ' + intTostr(X2) + ' Y= ' + intTostr(Y2);
  ELabel.Caption := 'I_@@@ X= ' + intTostr(X3) + ' Y= ' + intTostr(Y3);
end;

//*****************
// ݒ
//*****************
procedure TForm1.GresetBtnClick(Sender: TObject);
begin
  Ghrest;                             // ␳OtZbg
end;

//**************************************************************************************
// xWFȐ̍}
// xWFȐ͔}ϐ\Œ` t0`1ŕωƁAȐ̓_擾o܂B
//
// (x0, y0) n_(AJ[_)
// (x1, y1) _
// (x2, y2) _
// (x3, y3) I_(AJ[_)
//
// x = x(t) = t^3*x3 + 3*t^2*(1-t)*x2 + 3*t*(1-t)^2*x1 + (1-t)^3*x0
// y = y(t) = t^3*y3 + 3*t^2*(1-t)*y2 + 3*t*(1-t)^2*y1 + (1-t)^3*y0
//**************************************************************************************
procedure TForm1.BezierCurve;
var
  T100            : Integer;
  t               : Double;
  tm              : Double;
  B0, B1, B2, B3  : Double;
  X, Y            : Integer;
begin
  Image1.Canvas.Brush.Style := BsSolid;
  Image1.Canvas.Brush.Color := ClWhite;
  Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));  // Canvas 摜
  // g`
  Image1.Canvas.Pen.Color := clGray;
  Image1.Canvas.Pen.Style := PsSolid;
  Image1.Canvas.Pen.Width := 1;
  Image1.Canvas.MoveTo(0,  0);
  Image1.Canvas.LineTo(0, Image1.Height - 1);
  Image1.Canvas.LineTo(Image1.Width - 1, Image1.Height - 1);
  Image1.Canvas.LineTo(Image1.Width - 1, 0);
  Image1.Canvas.LineTo(0, 0);
  Image1.Canvas.Pen.Style := Psdot;
  Image1.Canvas.MoveTo(0,  85);
  Image1.Canvas.LineTo(Image1.Width - 1, 85);
  Image1.Canvas.MoveTo(0,  170);
  Image1.Canvas.LineTo(Image1.Width - 1, 170);
  Image1.Canvas.MoveTo(85,  0);
  Image1.Canvas.LineTo(85, Image1.Height - 1);
  Image1.Canvas.MoveTo(170,  0);
  Image1.Canvas.LineTo(170,Image1.Height - 1);

  // xWFȐ`
  Image1.Canvas.Pen.Color := clGray;
  Image1.Canvas.Pen.Style := PsSolid;
  Image1.Canvas.Pen.Width := 1;
  Image1.Canvas.MoveTo(0,  MHeight - Y0);               // n_̈ʒuֈړ n_
  Image1.Canvas.LineTo(X0, MHeight - Y0);               // xWFȐJn_
  for T100 := 0 to 100 do begin                         // [P܂ł0.01݂ŃxWFȐvZ
    t := T100 / 100;
    tm := (1 - t);
    B0 := tm * Tm * tm;
    B1 := 3 * t * tm * tm;
    B2 := 3 * t * t * tm;
    B3 := t * t * t;
    X :=           Round(X0 * B0 + X1 * B1 + X2 * B2 + X3 * B3);
    Y := MHeight - Round(Y0 * B0 + Y1 * B1 + Y2 * B2 + Y3 * B3);
    Image1.Canvas.LineTo(X, Y);                         // vZʍW֐܂
  end;
  Image1.Canvas.LineTo(Image1.Width - 1, Y);            // ŏI_܂ I_
  // e[uz̃f[^[\
  image1.Canvas.Pen.Color := clBlack;
  image1.Canvas.Pen.Width := 2;
  image1.Canvas.MoveTo(0, 256 - Dpalette[0]);
  for x := 0 to 255 do begin
    y := 256 - Dpalette[x];
    Image1.Canvas.LineTo(x, Y);  // e[ulW֐܂
  end;
  // xWF_\ ە\
  with Image1.Canvas do begin
    Brush.Color := clFuchsia;
    Pen.Color := clFuchsia;
    DrawEllipse(X0, Y0);                  // n_
    Brush.Color := clBlue;
    Pen.Color := clBlue;
    DrawEllipse(X1, Y1);                  // _1
    Brush.Color := clGreen;
    Pen.Color := clGreen;
    DrawEllipse(X2, Y2);                  // _Q
    Brush.Color := clRed;
    Pen.Color := clRed;
    DrawEllipse(X3, Y3);                  // I_
  end;
end;

//*************************************************************
// xWFȐʏ}EX_E
// }EX_Eʒu̐F擾y̐Fɐݒ肻̈ʒuɉ~`
//*************************************************************
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  DotPixel : TColor;
begin
  DotPixel := Image1.Canvas.Pixels[X, Y];                                 // F擾
  Drawing := True;                                                        // }EX_EtOZbg
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.Brush.Style := bsClear;
  Image1.Canvas.Pen.Color := DotPixel;
  Image1.Canvas.Ellipse(X - MoveR, Y - MoveR, X + MoveR, Y  + MoveR);     // 擾FŊە`
  Origin := Point(X, Y);                                                  // W̕ۑ
  Label1.Caption := 'X= ' + intTostr(X) + ' Y= ' + intTostr(MHeight - Y); // W̒l\
end;

//**************************************
// }EX𓮂AÖʒủ~
// Vʒuɉ~`
//**************************************
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if Drawing then begin
    Image1.Canvas.Pen.Mode := pmNotXor;                                   // y[h Not Xor
    Image1.Canvas.Ellipse(Origin.X - MoveR, Origin.Y - MoveR, Origin.X + MoveR, Origin.Y + MoveR); // Ỏ~
    Image1.Canvas.Ellipse(X - MoveR, Y - MoveR,  X + MoveR, Y + MoveR);                            // VWɉ~`
    Origin := Point(X, Y);                                                  // VWۑ
    Label1.Caption := 'X= ' + intTostr(X) + ' Y= ' + intTostr(MHeight - Y); // W̒l\
  end;
  Image1.Canvas.Pen.Mode := pmCopy;                                         // y[hʏ
end;

//********************************************
// }EXグ炻̈ʒuɉ~`
// y̐FɂA_̒lύX
//********************************************
procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Drawing := False;                                     // }EX_EtO
  // x̒ĺA1 VtgĂ̂ 1 ` 256
  if Y > MHeight then Y := MHeight;                     // Y ̒l Max 256
  If Y < 1   then Y := 1;                               // Y ̒l Min 1
  if X > 255 then X := 255;                             // X ̒l Max 255
  If X < 0   then X := 0;                               // X ̒l Min 0
  // y̐FɂA_̔ʂƒl̐ݒ
  Image1.Canvas.Ellipse(X - MoveR, Y - MoveR,  X + MoveR, Y + MoveR);
  if Image1.Canvas.Pen.Color = clFuchsia then begin     // n_
    Y0 := MHeight - Y ;
    X0 := X;
    SLabel.Caption := 'n_@@@ X= ' + intTostr(X0) + ' Y= ' + intTostr(Y0);
  end;
  if Image1.Canvas.Pen.Color = ClBlue then begin        // _P
    Y1 := MHeight - Y;
    X1 := X;
    C1Label.Caption := '_P@X= ' + intTostr(X1) + ' Y= ' + intTostr(Y1);
  end;
  if Image1.Canvas.Pen.Color = ClGreen then begin       // _Q
    Y2 := MHeight - Y;
    X2 := X;
    C2Label.Caption := '_Q@X= ' + intTostr(X2) + ' Y= ' + intTostr(Y2);
  end;
  if Image1.Canvas.Pen.Color = clRed then begin         // I_
    Y3 := MHeight - Y;
    X3 := X;
    ELabel.Caption := 'I_@@@ X= ' + intTostr(X3) + ' Y= ' + intTostr(Y3);
  end;
  Label1.Caption := 'X= ' + intTostr(X) + ' Y= ' + intTostr(MHeight - Y);
  BezierTableSet;
  BezierCurve;                                          // xWFȐ`
end;

//****************************
// }\
//****************************
procedure TForm1.SorceBtnClick(Sender: TObject);
begin
  Image2.Canvas.StretchDraw(VRect, InputDBitmap);             // o͘gɕϔ{o
end;

end.
